#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  noexec = 7,
  xtrace = 8,
  verbose = 9,
  noglob = 10,
  noclobber = 11,
  errtrace = 12,
  posix = 13,
  vi = 14,
  emacs = 15,
  interactive = 16,
  hashall = 17,
  lastpipe = 18,
  failglob = 19,
  extglob = 20,
  nocasematch = 21,
  eval_unsafe_arith = 22,
  ignore_flags_not_impl = 23,
  ignore_shopt_not_impl = 24,
  _allow_command_sub = 25,
  _allow_process_sub = 26,
  dynamic_scope = 27,
  redefine_const = 28,
  redefine_source = 29,
  _running_trap = 30,
  _running_hay = 31,
  _no_debug_trap = 32,
  _no_err_trap = 33,
  strict_parse_slice = 34,
  strict_argv = 35,
  strict_arith = 36,
  strict_array = 37,
  strict_control_flow = 38,
  strict_errexit = 39,
  strict_nameref = 40,
  strict_word_eval = 41,
  strict_tilde = 42,
  strict_glob = 43,
  parse_at = 44,
  parse_proc = 45,
  parse_func = 46,
  parse_brace = 47,
  parse_bracket = 48,
  parse_equals = 49,
  parse_paren = 50,
  parse_ysh_string = 51,
  parse_triple_quote = 52,
  simple_word_eval = 53,
  dashglob = 54,
  command_sub_errexit = 55,
  process_sub_fail = 56,
  xtrace_rich = 57,
  xtrace_details = 58,
  sigpipe_status_ok = 59,
  env_obj = 60,
  parse_at_all = 61,
  parse_backslash = 62,
  parse_backticks = 63,
  parse_dollar = 64,
  parse_ignored = 65,
  parse_sh_arith = 66,
  parse_dparen = 67,
  parse_dbracket = 68,
  parse_bare_word = 69,
  no_exported = 70,
  no_init_globals = 71,
  simple_echo = 72,
  simple_eval_builtin = 73,
  simple_test_builtin = 74,
  expand_aliases = 75,
  progcomp = 76,
  histappend = 77,
  hostcomplete = 78,
  cmdhist = 79,
  assoc_expand_once = 80,
  autocd = 81,
  cdable_vars = 82,
  cdspell = 83,
  checkhash = 84,
  checkjobs = 85,
  checkwinsize = 86,
  complete_fullquote = 87,
  direxpand = 88,
  dirspell = 89,
  dotglob = 90,
  execfail = 91,
  extdebug = 92,
  extquote = 93,
  force_fignore = 94,
  globasciiranges = 95,
  globstar = 96,
  gnu_errfmt = 97,
  histreedit = 98,
  histverify = 99,
  huponexit = 100,
  interactive_comments = 101,
  lithist = 102,
  localvar_inherit = 103,
  localvar_unset = 104,
  login_shell = 105,
  mailwarn = 106,
  no_empty_cmd_completion = 107,
  nocaseglob = 108,
  progcomp_alias = 109,
  promptvars = 110,
  restricted_shell = 111,
  shift_verbose = 112,
  sourcepath = 113,
  xpg_echo = 114,
  ARRAY_SIZE = 115,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  readonly = 10,
  local = 11,
  declare = 12,
  typeset = 13,
  export_ = 14,
  extern_ = 15,
  true_ = 16,
  false_ = 17,
  try_ = 18,
  assert_ = 19,
  read = 20,
  echo = 21,
  printf = 22,
  mapfile = 23,
  readarray = 24,
  cd = 25,
  pushd = 26,
  popd = 27,
  dirs = 28,
  pwd = 29,
  source = 30,
  umask = 31,
  ulimit = 32,
  wait = 33,
  jobs = 34,
  fg = 35,
  bg = 36,
  shopt = 37,
  complete = 38,
  compgen = 39,
  compopt = 40,
  compadjust = 41,
  compexport = 42,
  getopts = 43,
  builtin = 44,
  command = 45,
  type = 46,
  hash = 47,
  help = 48,
  history = 49,
  alias = 50,
  unalias = 51,
  bind = 52,
  append = 53,
  write = 54,
  json = 55,
  json8 = 56,
  pp = 57,
  hay = 58,
  haynode = 59,
  use = 60,
  error = 61,
  failed = 62,
  fork = 63,
  forkwait = 64,
  redir = 65,
  fopen = 66,
  shvar = 67,
  ctx = 68,
  invoke = 69,
  runproc = 70,
  boolstatus = 71,
  test = 72,
  bracket = 73,
  push_registers = 74,
  source_guard = 75,
  is_main = 76,
  cat = 77,
  ARRAY_SIZE = 78,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
